SYS7/A 	ORG	4E00H
 ; SYS7/ASM
 	DB	'FD'
 	DW	DIR,FREE,RET,RET,RET,RET,RET,RET
 	DW	RET,RET,RET,RET,RET,RET,RET
 POSHL	EQU	43E5H
 DREAD	EQU	43F4H
 GETTKS	EQU	43FAH
 SELECT	EQU	43DCH
 GETDIR	EQU	43C9H
 DRVTBL	DB	0,0,0,0,0,0,0,0		;drive use table
 FLAG	DB	0		;flag byte
 ;bit 0= A, 1= I, 2= S, 3= D
 DIR	CALL	POSHL		;check for params
 	JP	C,GODIR		;nothing
 	JP	Z,GODIR		; semicolon separator
 	LD	A,(HL)		;get the byte
 	INC	HL		;point to next
 	CP	'('		;param
 	JR	Z,DIR		;parse it out
 	CP	')'
 	JR	Z,DIR
 	CP	':'		;drive ?
 	JR	Z,DRVHAV	;get next byte
 	CP	38H		;drive spec ?
 	JR	C,HAVDRV	;compute drive
 	AND	5FH		;remove lower case
 	CP	'A'
 	JR	Z,ALLOC
 	CP	'I'
 	JR	Z,INVIS
 	CP	'S'
 	JR	Z,SYS
 	CP	'D'
 	JR	Z,DEAD
 	DEC	HL		;move pointer back
 PARERR	PUSH	HL
 	LD	HL,PARMSG
 	CALL	S4467H
 	POP	HL
 PARLP	LD	A,(HL)		;get a byte
 	CP	';'
 	JR	Z,PARDN
 	CP	13
 	JR	Z,PARDN
 	CALL	VOUT
 	INC	HL
 	JR	PARLP
 PARDN	LD	A,13
 	JP	VOUT
 ALLOC	LD	A,(FLAG)
 	OR	1
 DIRCONT	LD	(FLAG),A
 	JR	DIR
 INVIS	LD	A,(FLAG)
 	OR	2
 	JR	DIRCONT
 SYS	LD	A,(FLAG)
 	OR	4
 	JR	DIRCONT
 DEAD	LD	A,(FLAG)
 	OR	8
 	JR	DIRCONT
 PARMSG	DB	'Syntax Error!  ?',3
 DRVHAV	LD	A,(HL)		;get next byte
 	INC	HL
 HAVDRV	SUB	30H		;remove ascii
 	JR	C,PARERR	;bad input
 	CP	8
 	JR	NC,PARERR
 	PUSH	HL		;save string pointer
 	LD	HL,DRVTBL	;point to table
 	ADD	A,L
 	LD	L,A
 	INC	(HL)		;make it active
 	POP	HL
 	JP	DIR		;continue
 GODIR	LD	HL,DRVTBL
 	LD	B,8		;go 8 times
 GODIRL	LD	A,(HL)
 	INC	HL
 	OR	A
 	JR	NZ,GODIR2
 	DJNZ	GODIRL
 	LD	HL,DRVTBL
 	INC	(HL)		;default to drive 0
 GODIR2	XOR	A		;start with drive 0
 	LD	(PLACE),A
 DIRLOOP	CALL	ZINIT		;zero out tracks, etc.
 	LD	A,0
 PLACE	EQU	$-1
 	LD	HL,DRVTBL
 	ADD	A,L
 	LD	L,A
 	DEC	(HL)
 	CALL	Z,SHODIR	;active drive
 	LD	A,(PLACE)
 	INC	A
 	LD	(PLACE),A
 	CP	8
 	JR	C,DIRLOOP
 	XOR	A
 RET	RET
 SHODIR	LD	A,(PLACE)	;get position
 	CALL	SETDRV		;setup drive bit
 	CALL	STAT		;any disk there ?
 	RET	NZ		;non-available
 	XOR	A
 	LD	(COUNT),A
 	LD	E,A
 	LD	BC,4200H	;buffer
 	CALL	DREAD
 	JP	NZ,4409H	;bad read, terminate
 	CALL	GETFREE		;get free into string
 	LD	HL,FREMSG	;point to string
 	CALL	S4467H		;display
 	LD	A,2
 	LD	(POSIT),A
 SHOLOOP	LD	E,0
 POSIT	EQU	$-1
 	LD	BC,4200H
 	CALL	DREAD
 	JP	NZ,4409H
 	LD	IX,4200H
 	LD	B,8		;8 entries/sector
 SECLP	BIT	4,(IX)		;active ?
 	CALL	NZ,SHOWIT	;display it
 	LD	DE,20H		;go to next one
 	ADD	IX,DE
 	DJNZ	SECLP		;finish this sector
 	LD	A,(POSIT)
 	INC	A
 	LD	(POSIT),A	;next sector
 	CP	10		;till end of track
 	JR	C,SHOLOOP
 	LD	A,0		;get active count
 COUNT	EQU	$-1
 	LD	B,A		;here for subtrack
 	LD	A,48		;48 available
 	SUB	B		;less used
 	LD	B,A		;for count
 	LD	HL,FILES+2	;point to string
 AA1	CALL	ADD1		;increment string
 	DJNZ	AA1
 	LD	A,(4020H)	;get cursor posit
 	AND	3FH		;at beginning of line?
 	JR	Z,SHOWHER
 	LD	A,10
 	CALL	VOUT
 SHOWHER	LD	HL,FILMSG
 S4467H	PUSH	DE
 	CALL	4467H
 	POP	DE
 	RET
 FILMSG	DB	'***  '
 SPACE	DB	'000 Free Granules, '
 FILES	DB	'000 Free Files  ***',10,13
 SHOWIT	LD	A,(COUNT)	;bump used space count
 	INC	A
 	LD	(COUNT),A
 	BIT	7,(IX)
 	RET	NZ
 	BIT	6,(IX)		;system file ?
 	JR	Z,CKVIS
 	LD	A,(FLAG)
 	BIT	2,A		;system request ?
 	JR	NZ,DIRENT	;display it if yes
 	RET
 CKVIS	BIT	3,(IX)		;invisible ?
 	JR	Z,DIRENT	;continue if not
 	BIT	1,A		;invisible request ?
 	RET	Z		;nope
 DIRENT	PUSH	BC		;save counter
 	LD	BC,1008H	;b=screen space, c=name
 	PUSH	IX		;save pointer
 SH1	LD	A,(IX+5)	;get name byte
 	INC	IX		;point to next
 	CP	20H		;space ?
 	JR	Z,SH2		;skip it if yes
 	CALL	VOUT
 	DEC	B		;1 byte displayed
 SH2	DEC	C		;go for 8 byte name
 	JR	NZ,SH1		;continue till name end
 	LD	A,(IX+5)	;any extension ?
 	CP	20H
 	JR	Z,SH4		;skip if not extension
 	LD	C,3		;3 bytes long
 	LD	A,'/'
 	CALL	VOUT
 	DEC	B
 SH3	LD	A,(IX+5)
 	INC	IX
 	CP	20H
 	JR	Z,SH3A
 	CALL	VOUT
 	DEC	B
 SH3A	DEC	C
 	JR	NZ,SH3
 SH4	LD	A,20H
 	CALL	VOUT
 	DEC	B
 	POP	IX		;restore pointer
 	BIT	6,(IX)		;system ?
 	JR	Z,SH5
 	LD	A,'S'
 	CALL	VOUT
 	DEC	B
 	JR	SH6
 SH5	BIT	3,(IX)		;invisible
 	JR	Z,SH6
 	LD	A,'I'
 	CALL	VOUT
 	DEC	B
 SH6	LD	A,(IX)
 	AND	7		;get low 3 bits
 	JR	Z,SH7		;no protection
 	ADD	A,30H		;make it ascii
 	CALL	VOUT
 	DEC	B
 SH7	LD	A,20H
 SH8	CALL	VOUT		;spaces till end
 	DJNZ	SH8
 	POP	BC		;restore loop counter
 	RET
 FREMSG	DB	':'
 FDRV	DB	'0 '
 NAME	DB	'xxxxxxxx '
 DATE	DB	'xxxxxxxx, '
 TRAKS	DB	'000 Tracks, '
 LOCKED	DB	'000 Locked Out, Dir='
 DTK	DB	'000.',13
 GETFREE	LD	HL,42D0H	;point to name
 	LD	DE,NAME
 	LD	BC,8
 	PUSH	BC
 	LDIR
 	POP	BC
 	LD	DE,DATE
 	LDIR
 	LD	A,(PLACE)	;get binary drive
 	ADD	A,30H		;make it ascii
 	LD	(FDRV),A
 	OR	A		;clear carry for table
 	CALL	GETTKS		;get track count
 	LD	(SAVEA),A	;save it for later
 	LD	B,A		;for loop count
 	PUSH	BC		;save count on stack
 	LD	HL,TRAKS+2	;tracks ascii
 TKLP	CALL	ADD1		;bump ascii string
 	DJNZ	TKLP
 ; ***********************
 	OR	A		;clear carry
 	CALL	GETDIR		;get directory track
 	LD	B,A
 	LD	HL,DTK+2
 DTLP	CALL	ADD1
 	DJNZ	DTLP
 ; ***********************
 	POP	BC		;restore count
 	LD	DE,4200H	;allocation table
 	LD	HL,SPACE+2	;string
 FRELP	LD	A,(DE)
 	RRCA
 	CALL	NC,ADD1
 	RRCA
 	CALL	NC,ADD1
 	INC	DE
 	DJNZ	FRELP
 	LD	B,0
 SAVEA	EQU	$-1
 	LD	DE,4260H
 	LD	HL,LOCKED+2
 LKLP	LD	A,(DE)
 	RRCA
 	CALL	C,ADD1
 	RRCA
 	CALL	C,ADD1
 	INC	DE
 	DJNZ	LKLP
 	RET
 ADD1	PUSH	AF		;save byte
 	PUSH	HL		;save position
 	LD	A,(HL)
 	INC	A
 	LD	(HL),A
 	CP	3AH		;past '9' ?
 	JR	C,ADD2		;done if not
 	LD	(HL),'0'
 	DEC	HL
 	JR	ADD1+2		;bump next digit
 ADD2	POP	HL		;get string point back
 	POP	AF
 	RET			;done
 SETDRV	LD	(4308H),A	;save binary drive
 	LD	B,1
 SETLP	OR	A
 	JR	Z,DRVSET
 	SLA	B
 	DEC	A
 	JR	SETLP
 DRVSET	LD	A,B		;get drive bit
 	LD	(4309H),A	;save for drive select
 	RET
 STAT	CALL	SELECT		;turn on drive
 	RET	NZ		;not available
 	LD	BC,0CDH
 ST1	DEC	BC
 	LD	A,B
 	OR	C
 	JR	Z,STBAD
 	LD	A,(37ECH)
 	AND	2
 	JR	NZ,ST1
 	LD	BC,199DH
 ST2	DEC	BC
 	LD	A,B
 	OR	C
 	JR	Z,STBAD
 	LD	A,(37ECH)
 	AND	2
 	JR	Z,ST2
 	LD	BC,0BAH
 ST3	DEC	BC
 	LD	A,B
 	OR	C
 	JR	Z,STBAD
 	LD	A,(37ECH)
 	AND	2
 	JR	NZ,ST3
 	RET
 STBAD	OR	1		;set nz flag
 	RET
 ZINIT	LD	HL,3030H
 	LD	(DTK),HL
 	LD	(DTK+1),HL
 	LD	(TRAKS),HL
 	LD	(TRAKS+1),HL
 	LD	(SPACE),HL
 	LD	(SPACE+1),HL
 	LD	(LOCKED),HL
 	LD	(LOCKED+1),HL
 	LD	(FILES),HL
 	LD	(FILES+1),HL
 	RET
 FREE	CALL	POSHL		;check for params
 	JR	C,GOFREE
 	JR	Z,GOFREE
 	LD	A,(HL)
 	INC	HL
 	CP	':'		;drive ?
 	JR	Z,DRVFRE
 	CP	38H
 	JR	C,FREDRV
 	JP	PARERR-1
 DRVFRE	LD	A,(HL)
 	INC	HL
 FREDRV	SUB	30H
 	JP	C,PARERR-1
 	CP	8
 	JP	NC,PARERR-1
 	PUSH	HL
 	LD	HL,DRVTBL
 	ADD	A,L
 	LD	L,A
 	INC	(HL)
 	POP	HL
 	JR	FREE
 GOFREE	LD	B,8		;any drives specified?
 	LD	HL,DRVTBL
 GOFLP	LD	A,(HL)
 	INC	HL
 	OR	A
 	JR	NZ,GOFL1
 	DJNZ	GOFLP
 	LD	HL,0101H
 	LD	(DRVTBL),HL
 	LD	(DRVTBL+2),HL
 	LD	(DRVTBL+4),HL
 	LD	(DRVTBL+6),HL	;set all drives active
 GOFL1	XOR	A
 	LD	(PLACE),A
 GOFRELP	LD	A,(PLACE)
 	LD	HL,DRVTBL
 	ADD	A,L
 	LD	L,A
 	DEC	(HL)
 	CALL	Z,SHOFREE
 	LD	A,(PLACE)
 	INC	A
 	LD	(PLACE),A
 	CP	8
 	RET	NC
 	JR	GOFRELP
 SHOFREE	LD	A,(PLACE)
 	CALL	SETDRV
 	CALL	STAT
 	RET	NZ
 	CALL	ZINIT		;zero's into string
 	LD	BC,4200H
 	LD	E,0
 	CALL	DREAD
 	JP	NZ,4409H
 	CALL	GETFREE
 	LD	HL,FREMSG
 	JP	S4467H		;display & return
 VOUT	PUSH	DE
 	CALL	33H
 	POP	DE
 	RET
 	END	4E00H
CALL	ZINIT		;zero's into string
 	LD	BC,4200H
 	LD	E,0
 	CALL	DREAD
 	JP	NZ,4409H
 	CALL	GETFREE
 	LD	HL,FREMSG
 	JP	S4467H		;display & return
 VOUT	PUSH	DE
RETURN
 	CALL	OUTPTR		;PRINT IT
 VIDNEX	POP	HL	